<?

 /*****************************************************************************
 * Filename: api/xml/request.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 $_path["root"]="../../";
 require($_path["root"]."include.php");

 if($_session->inBackend()) //backend project
  $_session->frontend(); //switch to frontend project

 if($_config->get("benchmark"))
 {
  require_once($_path["include"]."benchmark.php");
  $_benchmark=new Benchmark();
 }

 require_once($_path["format"]."xml.php");
 require_once($_path["api"]."xml.php");

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
 <head>
  <title>JAS XML interface tester</title>
  <style>
   body
   {
    font-size: 8pt;
    font-family: verdana;
   }
   ul
   {
    list-style-type: decimal;
    margin: 0px 0px 0px 50px;
    padding: 0px;
   }
   form textarea,
   form input
   {
    float: left;
    vertical-align: top;
   }
  </style>

  <script type="text/javascript">
   function setXML(type)
   {
    var xml="";
    switch(type)
    {
     case "language":
     {
      xml="&lt;language set=\"modules\" language=\"nl\" /&gt;";
      break;
     }
     case "projects":
     {
      xml="&lt;projects /&gt;";
      break;
     }
     case "modules":
     {
      xml="&lt;modules all=\"true\"/&gt;";
      break;
     }
     case "module":
     {
      xml="&lt;modules&gt;&lt;module name=\"categories\" /&gt;&lt;/modules&gt;";
      break;
     }
     case "data":
     {
      xml="&lt;data module=\"categories\" action=\"view\" extra=\"all\"&gt;\n  &lt;show&gt;\n   &lt;field name=\"ordernr\" /&gt;\n   &lt;field name=\"name\" /&gt;\n  &lt;/show&gt;\n  &lt;sort&gt;\n   &lt;field name=\"ordernr+\" /&gt;\n  &lt;/sort&gt;\n  &lt;mutilations&gt;\n   &lt;mutilation name=\"name\" type=\"strip\" arg1=\"15\" /&gt;\n  &lt;/mutilations&gt;\n &lt;/data&gt;";
      break;
     }
     default: break;
    }

    xml="&lt;?xml version=\"1.0\" encoding=\"ISO-8859-1\"?&gt;\n&lt;jas version=\"1.0\"&gt;\n "+xml+"\n&lt/jas&gt;";
    document.getElementById("request").innerHTML=xml;
   }
  </script>
 </head>

 <body>
 <form action="request.php">
  <textarea name="request" id="request" style="width: 600px; height: 400px;"><?=(isset($_REQUEST["request"])?$_REQUEST["request"]:"")?></textarea>
  <input type="submit" value="Language" onclick="setXML('language')" />
  <input type="submit" value="Projects" onclick="setXML('projects')" />
  <input type="submit" value="Modules" onclick="setXML('modules')" />
  <input type="submit" value="Module" onclick="setXML('module')" />
  <input type="submit" value="Data" onclick="setXML('data')" />
  <br/><br/><input type="submit" value="Submit"/>
 </form>
 <br style="clear: both;" />
 <?

 if($_benchmark) $_benchmark->start("API_XML");
 $api=new API_XML("server");

 if($_benchmark) $_benchmark->start("Parse");
 $ret=$api->parse((isset($_REQUEST["request"])?$_REQUEST["request"]:""));
 if($_benchmark) $_benchmark->stop();
 if(!$ret)
 {
  if($_benchmark) $_benchmark->start("Error");
  $api->error();
  if($_benchmark) $_benchmark->stop();
 }
 else
 {
  if($_benchmark) $_benchmark->start("Commands");
  $ret=$api->commands();
  if($_benchmark) $_benchmark->stop();
  if(!$ret)
  {
   if($_benchmark) $_benchmark->start("Error");
   $api->error();
   if($_benchmark) $_benchmark->stop();
  }
  else
  {
   if($_benchmark) $_benchmark->start("Format");
   $ret=$api->format();
   if($_benchmark) $_benchmark->stop();
   if(!$ret)
   {
    if($_benchmark) $_benchmark->start("Error");
    $api->error();
    if($_benchmark) $_benchmark->stop();
   }
  }
 }


 if($_benchmark) $_benchmark->start("Output");
 $xml=new Format_XML();
 if(!$xml->parse($api->output(false)))
  print $xml->e->show();
 else
  print $xml->display();
 if($_benchmark) $_benchmark->stop();
 
 if($_benchmark) $_benchmark->stop();
 if($_benchmark) print "<br/>".$_benchmark->show();

 ?>
 </body>
</html>
