<?

 /*****************************************************************************
 * Filename: files/index.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 ini_set("display_errors", 0); //don't show PHP errors in API

 $_path["root"]="../";
 require($_path["root"]."include.php");

 if($_session->inBackend()) //backend project
  $_session->frontend(); //switch to frontend project

 require_once($_path["include"]."functions.php");
 require_once($_path["include"]."errors.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."mime.php");
 require_once($_path["include"]."fs.php");

 $e=new Errors();

 //parse request vars
 if($p=request("p")) //mod rewrite
 {
  $start=false;
  $pSize=sizeof($p);

  for($c=0;$c<$pSize;$c++)
  {
   if(preg_match("/^\d+$/", $p[$c])) //first number found (nr field)
   {
    if($c>=2)//../module/field/nr/
    {
     $module=$p[$c-2];
     $field=$p[$c-1];
     $nr=$p[$c];
    }
    else if($c==1)//module/nr/
    {
     $module=$p[$c-1];
     $nr=$p[$c];
    }
    else //nr/
     $nr=$p[$c];

    if(isset($nr))
    {
     $start=$c+1;
     break;
    }
   }
  }

  if($start&&$start<$pSize)
  {
   for($c=$start;$c<$pSize;$c++) //..nr/width/100/height/200/nocache/rotate/left/ (order may vary)
   {
    switch($p[$c])
    {
     case "redirect":
     {
      $redirect=true;
      break;
     }
     case "md5":
     {
      $md5=true;
      break;
     }
     default: //unknown argument
      break;
    }
   }
  }

  unset($pSize, $c, $start);
 }
 else
 {
  $module=request("m");
  $field=request("field");
  $nr=request("nr");

  $redirect=isset($_GET["redirect"]);
  $md5=isset($_GET["md5"]);
 }
 unset($p);


 //validate request vars
 if(isset($module)&&$module)
  $module=strip_tags($module);
 else
  $module="files";

 if(isset($field)&&$field)
  $field=strip_tags($field);
 else
  $field=false;

 if(isset($nr)&&$nr)
  $nr=strip_tags($nr);
 else
  $nr=0;

 if(isset($redirect)&&$redirect)
  $redirect=true;
 else
  $redirect=false;

 if(isset($md5)&&$md5)
  $md5=true;
 else
  $md5=false;


 //select module
 $d=new Data($module, "view", "item");

 //identifier
 $d->setValue($d->getID(), $nr);

 //module field to download
 if($field)
 {
  if(!$d->check("type", "image", $field)&&!$d->check("type", "file", $field)&&!$d->check("type", "localfile", $field))
   $e->add("Incorrect file field for module: \"".$module."\"", "hack");
 }
 else // autodetect
 {
  //get first file field
  foreach($d->check("type", "image") as $field)
   break;

  if(!$field)
  {
   //get first local file field
   foreach($d->check("type", "localfile") as $field)
    break;

   if(!$field)
   {
    //get first image field
    foreach($d->check("type", "file") as $field)
     break;

    if(!$field)
     $e->add("No file field for module: \"".$module."\"", "hack");
   }
  }
 }

 if($md5&&!$d->check("properties", "md5", $field))
  $e->add("No MD5 hash for module: \"".$module."\" field: \"".$field."\"", "error");

 if(!$e->any("fatal"))
 {
  if($md5) //get md5 hash file
   $showFields=Array($field, $field."MD5");
  else //get file
   $showFields=Array($field, $field."Data", $field."Type", $field."Size");

  if($d->check("properties", "count", $field))
   $showFields[]=$field."Count";

  $d->setShowFields($showFields);

  if(!$d->get())
   $e->add($d->e);
  else if(!$d->next())
   $e->add("No file data for module: \"".$module."\"", "error");
  else if($md5&&!$d->v[$field."MD5"])
   $e->add("No MD5 hash for file: \"".$d->v[$field]."\"", "error");
 }

 if($e->any("fatal"))
 {
  print $e->show("fatal");
  print "<a href=\"javascript: back();\">Back</a>";
 }
 else
 {
  if($d->check("type", "localfile", $field)) //local file
  {
   $filename=$d->v[$field];
   $file=$d->field[$field]["localpath"]["directory"].$filename;

   if($redirect)
   {
    header("Location: ".$_path["HTML"]["prefix"].$file);
    exit;
   }

   $mime=new Mime();

   if(!($type=$mime->file($file)))
    $type="application/octet-stream";

   $data=FS::readS($file);
   $size=FS::sizeS($file);
  }
  else if($md5) //md5 hash
  {
   $filename=$d->v[$field].".md5";
   $type="text/plain";
   $data=$d->v[$field."MD5"]."  ".$d->v[$field]."\n";
   $size=strlen($data);
  }
  else //normal file field
  {
   $filename=$d->v[$field];
   $type=$d->v[$field."Type"];
   $data=$d->v[$field."Data"];
   $size=$d->v[$field."Size"];
  }

  //increase counter for non md5 downloads
  if(!$md5&&$d->check("properties", "count", $field))
  {
   unset($d->field["updated"]); //ensure last updated isn't adjusted

   $count=$d->v[$field."Count"];

   $d->setAction("edit");
   $d->setExtra("item");

   $d->clearValues();
   $d->setValue($d->getID(), $nr);
   $d->setValue($field."Count", $count+1);

   $d->submit();
  }

  header("Content-type: ".$type);
  header('Content-Disposition: attachment; filename="'.$filename.'"');
  header("Content-Length: ".$size);

  print $data;
  exit;
 }
?>
