<?

 /*****************************************************************************
 * Filename: include/modules/mimetypes.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class System_Module_MimeTypes extends Module
 {
  function __construct(&$data)
  {
   parent::__construct($data);

   $this->data->title="Mime types";
   $this->data->addField("mime", "regexp", "all", "title", 3, 25, false, "Mime type");
   $this->data->regexps("mime", "!^[^/]+/[^/]+!");

   $this->data->addField("extension", "text", "all", false, 0, 25, false, "Extension");
   $this->data->addField("content", "html", "all", false, 0, 25, false, "Content start");

   $this->data->addUnique("extension", "mime", "extension", "content");
   $this->data->sortOrder("mime-");
  }
 }
?>
