<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/diff.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."diff.php");

 class UT_Diff extends UT_Classes
 {
  var $string1="line 1
line 2
line 3
line 4
line 6
line 7
line 8
line 9
line 10";

  var $string2="line 1
line 2
line 3a
line 4
line 5
line 6
line 9";

  var $diff1="=line 1
=line 2
!line 3
=line 4
-
=line 6
+line 7
+line 8
=line 9
+line 10";

  var $diff2="=line 1
=line 2
!line 3a
=line 4
+line 5
=line 6
-
-
=line 9
-";

  function Constructor()
  {
   $object=new Diff();

   if(!is_object($object)||get_class($object)!="Diff")
   {
    $this->e->add("Constructor doesn't return a Diff object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Copy_Constructor()
  {
   $orig=new Diff();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("Diff object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->e->errors=-1;
   if($orig->e->errors==$copy->e->errors)
   {
    $this->e->add("Diff object copy also modified original \"Error\" object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Arrays()
  {
   $diff=new Diff();

   $array1=explode("\n", $this->string1);
   $array2=explode("\n", $this->string2);

   if(!$diff->arrays($array1, $array2))
   {
    $this->e->add($diff->e);
    return UT_FAILED;
   }

   $string1=implode("\n", $array1);
   $string2=implode("\n", $array2);

   if($string1!=$this->diff1)
   {
    $this->e->add("First diff doesn't match expected output");
    return UT_FAILED;
   }

   if($string2!=$this->diff2)
   {
    $this->e->add("Second diff doesn't match expected output");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Strings()
  {
   $diff=new Diff();

   $string1=$this->string1;
   $string2=$this->string2;

   if(!$diff->strings($string1, $string2))
   {
    $this->e->add($diff->e);
    return UT_FAILED;
   }

   if($string1!=$this->diff1)
   {
    $this->e->add("First diff doesn't match expected output");
    return UT_FAILED;
   }

   if($string2!=$this->diff2)
   {
    $this->e->add("Second diff doesn't match expected output");
    return UT_FAILED;
   }

   return UT_OK;
  }

 }

?>
