<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/jas.sro.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["plugins"]."unit_testing/ut/jas.php");
 require_once($_path["include"]."jas.php");

 class UT_JAS_Scope_Resolution_Operator extends UT_JAS
 {
  function CallStatic()
  {
   if(!JAS::versionS())
   {
    $this->e->add("versionS shouldn't fail", "error");
    return UT_FAILED;
   }

   /*
   if(($nonexistingexecutable=JAS::nonexistingexecutableS()))
   {
    $this->e->add("nonexistingexecutableS should fail", "error");
    return UT_FAILED;
   }
   */

   return UT_OK;
  }


  function Version()
  {
   global $_path;

   if(!($changelog=file_get_contents($_path["include"]."changelog.txt")))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   if(!preg_match("/\nVersion ([0-9\.]+)[ \-]*([A-Z0-9]+)?/i", $changelog, $version))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   $development=(preg_match("/\nDevelopment version/", $changelog));

   if(!preg_match("/\n\t(\d{4}-\d{2}-\d{2})/", $changelog, $updated))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   $updated=DT::dateConvertS($updated[1], "Y-m-d");
   $modified=filemtime($_path["include"]."changelog.txt");

   //version
   if(!JAS::versionS())
   {
    $this->e->add("JAS version failed", "error");
    return UT_FAILED;
   }

   if(JAS::versionS()!=$version[1])
   {
    $this->e->add("JAS version doesn't match", "error");
    return UT_FAILED;
   }

   if(!JAS::versionS("version"))
   {
    $this->e->add("JAS version failed", "error");
    return UT_FAILED;
   }

   if(JAS::versionS("version")!=$version[1])
   {
    $this->e->add("JAS version doesn't match", "error");
    return UT_FAILED;
   }

   //tag
   if(JAS::versionS("tag")===false)
   {
    $this->e->add("JAS version tag failed", "error");
    return UT_FAILED;
   }

   if(JAS::versionS("tag")!=(isset($version[2])?$version[2]:""))
   {
    $this->e->add("JAS version tag doesn't match", "error");
    return UT_FAILED;
   }

   //development
   if(JAS::versionS("development")!=$development)
   {
    $this->e->add("JAS version development doesn't match", "error");
    return UT_FAILED;
   }

   //updated
   if(!JAS::versionS("updated"))
   {
    $this->e->add("JAS version updated failed", "error");
    return UT_FAILED;
   }

   if(JAS::versionS("updated")!=$updated)
   {
    $this->e->add("JAS version updated doesn't match", "error");
    return UT_FAILED;
   }

   //modified
   if(!JAS::versionS("modified"))
   {
    $this->e->add("JAS version modified failed", "error");
    return UT_FAILED;
   }

   if(JAS::versionS("modified")!=$modified)
   {
    $this->e->add("JAS version modified doesn't match", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }
 }


 class UT_Modules_Function_Scope_Resolution_Operator extends UT_JAS_Scope_Resolution_Operator
 {
  function isArray()
  {
   if(!is_array(JAS::modules()))
    return UT_FAILED;

   return UT_OK;
  }
  function WrongType()
  {
   if(sizeof(JAS::modules("asdasasdasdasdads"))>0)
    return UT_FAILED;

   return UT_OK;
  }
  function Categories()
  {
   if(!in_array("categories", JAS::modules("system")))
    return UT_FAILED;

   return UT_OK;
  }
  function Plugins()
  {
   if(!in_array("unit_testing_mutilate", JAS::modules("plugins", "unit_testing")))
    return UT_FAILED;

   return UT_OK;
  }
  function TableExists()
  {
   if(!in_array("categories", JAS::modules(false, false, true)))
    return UT_FAILED;

   return UT_OK;
  }
  function TableDoesntExists()
  {
   if(in_array("empty", JAS::modules("project", false, true)))
    return UT_FAILED;

   return UT_OK;
  }
 }


 class UT_Plugins_Function_Scope_Resolution_Operator extends UT_JAS_Scope_Resolution_Operator
 {
  function isArray()
  {
   if(!is_array(JAS::plugins()))
    return UT_FAILED;

   return UT_OK;
  }
  function WrongType()
  {
   if(sizeof(JAS::plugins("asdasasdasdasdads"))>0)
    return UT_FAILED;

   return UT_OK;
  }
  function Categories()
  {
   if(!in_array("unit_testing", JAS::plugins("system")))
    return UT_FAILED;

   return UT_OK;
  }
 }

 class UT_Projects_Function_Scope_Resolution_Operator extends UT_JAS_Scope_Resolution_Operator
 {
  function isArray()
  {
   if(!is_array(JAS::projects()))
    return UT_FAILED;

   return UT_OK;
  }
  function Exists()
  {
   if(!in_array("jas", JAS::projects()))
    return UT_FAILED;

   return UT_OK;
  }
 }

?>
