<?

 /*****************************************************************************
 * Filename: project/jas/include/backend/home.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["include"]."backend/base.php");
 require_once($_path["project"]["include"]."backend/navigation.php");
 require_once($_path["project"]["include"]."backend/online.php");

 class Backend_Home extends Backend_Base
 {
  function __construct(&$backend)
  {
   parent::__construct($backend);
  }

  function main($section=false)
  {
   //section
   if(!parent::main($section))
    return false;

   return true;
  }


  /*
   * Output
   */

  function output_default()
  {
   global $_config;

   $this->backend->setTitle($this->icon("jas_dim"),
    $this->link($_config->get("title"), Array("")));

   $r="<div class=\"home\">\n";

   if($updates=Backend_Online::updates($this))
    $r.="<div class=\"updates\">".$this->link($this->icon("updates_newer", "small"), Array("online/updates"), $this->language->t("Check for updates"))." ".$updates."</div>\n";

   if($entries=Backend_Navigation::navigation("home"))
    foreach($entries as $entry)
     $r.=" <div class=\"tile\">".$this->link(($entry["icon"]?$this->icon($entry["icon"])."<br/>":"").$entry["title"], Array($entry["path"]), $entry["title"])."</div>\n";

   $r.="</div>\n";

   return $r;
  }
 }
?>
