<?

 /*****************************************************************************
 * Filename: project/jas/include/backend/projects.users.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["include"]."backend/base.php");
 require_once($_path["project"]["include"]."backend/users.php");
 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."jas.php");

 class Backend_Projects_Users extends Backend_Base
 {
  function __construct(&$backend)
  {
   parent::__construct($backend);

   $this->data=false;
   $this->jasRootUser=false;
  }


  function data()
  {
   global $_session, $_config;

   $_session->frontend();

   //get categories
   $d=Data::cache("categories", "view", "all");
   $id=$d->getID();
   $catnr=$d->getRightsReference();
   $module="module";
   $d->setShowFields($id, $catnr, $module);

   $d->clearValues();
   
   $_config->su(true);
   $d->get();
   $_config->su();

   $topcatnr=false;
   $usercatnr=false;
   if($d->vmax) 
   {
    if($d->search($catnr, 0))
     $topcatnr=$d->v[$id];

    $d->reset();
    while($d->next())
    {
     if((is_array($d->v[$module])&&in_array($_config->get("usermodule"), $d->v[$module]))||$d->v[$module]==$_config->get("usermodule"))
     {
      $usercatnr=$d->v[$id];
      break;
     }
    }
   }

   //get users
   $d=Data::cache("users", "view", "all");
   $id=$d->getID();
   $username=$d->check("properties", "username")[0];
   $password=$d->check("properties", "password")[0];
   $d->setShowFields($id, $username);

   $d->clearValues();
   $d->setValue($id, $_config->get("rootnr"), 0);
   $d->setValue($id, $_config->get("anonnr"), 1);
   $d->setOperant($id, "OR");

   $_config->su(true);
   $d->get();
   $_config->su();

   $anonnr=false;
   $rootnr=false;
   $anonuser="anonymous";
   $rootuser="root";
   if($d->vmax)
   {
    if($d->search($id, $_config->get("anonnr")))
    {
     $anonnr=$d->v[$id];
     $anonuser=$d->v[$username];
    }

    $d->reset();
    if($d->search($id, $_config->get("rootnr")))
    {
     $rootnr=$d->v[$id];
     $rootuser=$d->v[$username];
    }
   }

   $_session->backend();

   $this->data=Data::cache("empty", "add", "item", Array("skipCheckTables" => true));
   $this->data->addField("topcatnr", "nr", "", "", 1, false, $topcatnr);
   $this->data->addField("usercatnr", "nr", "", "", 1, false, $usercatnr);
   $this->data->addField("anonnr", "nr", "", "", 1, false, $anonnr);
   $this->data->addField("rootnr", "nr", "", "", 1, false, $rootnr);

   $this->data->addField("anonuser", $d->field[$username]["type"], "all", "", $d->field[$username]["min"], $d->field[$username]["max"], $anonuser, "Anonymous username");
   $this->data->addField("rootuser", $d->field[$username]["type"], "all", "", $d->field[$username]["min"], $d->field[$username]["max"], $rootuser, "Root username");
   $this->data->addField("rootpass", $d->field[$password]["type"], "all", "password", $d->field[$password]["min"], $d->field[$password]["max"], "", "Root password");
   $this->data->field["verifyrootpass"]["title"]="Verify root password";

   $this->data->setRequestValues();
  }


  function status(&$text)
  {
   $this->data();

   $text="";
   if($this->data->getDefaultValue("topcatnr")===false||$this->data->getDefaultValue("usercatnr")===false) //doesn't exist yet
    $text.="categories";
   if($this->data->getDefaultValue("anonnr")===false||$this->data->getDefaultValue("rootnr")===false) //doesn't exist yet
    $text.=($text?" and ":"")."users";

   if($text)
   {
    $text="Required ".$text." don't exist";
    return "Failure";
   }

   return "Done";
  }

  function main($submit=true)
  {
   global $_session, $_config;

   $this->jasRootUser=$_config->userRoot(); //get jas project user root status
   if(!$this->jasRootUser)
   {
    $this->e->add("Project users can only be setup by the JAS root user", "error");
    return false;
   }

   $this->data();

   $_session->frontend();

   if(request("s")&&$submit)
   {
    //setup categories
    $d=Data::cache("categories", "add", "item");
    $id=$d->getID();
    $catnr=$d->getRightsReference();
    $name="name";
    $module="module";

    //add top category
    if($this->data->getDefaultValue("topcatnr")===false)
    {
     $d->field[$catnr]["min"]=0;

     $d->clearValues();
     $d->setValue($catnr, 0);
     $d->setValue($name, $_config->get("title"));

     $_config->su(true);
     if(!$d->submit())
     {
      $_config->su();
      $this->e->add($d->e);
      $_session->backend();
      return false;
     }
     else
      $_config->su();

     $this->data->field["topcatnr"]["defaultvalue"]=$d->getValue($id);
    }

    //add users category
    if($this->data->getDefaultValue("usercatnr")===false)
    {
     $d->clearValues();
     $d->setValue($catnr, $this->data->getDefaultValue("topcatnr"));
     $d->setValue($name, "Users");
     $d->setValue($module, $_config->get("usermodule"));

     $_config->su(true);
     if(!$d->submit())
     {
      $_config->su();
      $this->e->add($d->e);
      $_session->backend();
      return false;
     }
     else
      $_config->su();

     $this->data->field["usercatnr"]["defaultvalue"]=$d->getValue("nr");
    }
    
    //fix users category rights
    $d=Data::cache("groupRights", "view", "all");

    if(!($ds=$d->storageObject())) //submit directly via storage object to avoid "identifier" check
    {
     $this->e->add($d->e);
     $_session->backend();
     return false;
    }

    $d->clearValues(); 
    $d->setValue("nr", $this->data->getDefaultValue("usercatnr"));
    $d->setValue("catnr", $this->data->getDefaultValue("usercatnr"));
    
    $_config->su(true);
    if(!$d->get())
    {
     $_config->su();
     $this->e->add($d->e);
     $_session->backend();
     return false;
    }
    else
     $_config->su();
    
    if(!$d->next())
    {
     $d->setAction("add");
     $d->setValue("nr", $this->data->getDefaultValue("usercatnr"));
     $d->setValue("catnr", $this->data->getDefaultValue("usercatnr"));
     $d->setValue("rights", "0000000000000100"); //login rights

     $_config->su(true);
     if(!$ds->add())
     {
      $_config->su();
      $this->e->add($ds->e);
      $_session->backend();
      return false;
     }
     else
      $_config->su();
    }
    else //exists
    {
     $d->setAction("edit");
     $d->setValue("nr", $this->data->getDefaultValue("usercatnr"));
     $d->setValue("catnr", $this->data->getDefaultValue("usercatnr"));

     $rights=$d->v["rights"];
     $rights[13]="1"; //add login rights
     $d->setValue("rights", $rights);
     $d->field["rights"]["valuetype"]="request";

     $d->reset();

     $_config->su(true);
     if(!$ds->edit(true))
     {
      $_config->su();
      $this->e->add($ds->e);
      $_session->backend();
      return false;
     }
     else
      $_config->su();
    }

    
    //setup users
    $d=Data::cache($_config->get("usermodule"), "add", "item");
    $id=$d->getID();
    $catnr=$d->getRightsReference();
    $username=$d->check("properties", "username")[0];
    $password=$d->check("properties", "password")[0];

    //root user
    if($this->data->getDefaultValue("rootnr")===false)
    {
     $d->setAction("add");
     
     if(!$this->data->checkField("rootuser")||!$this->data->checkField("rootpass")||!$this->data->checkField("verifyrootpass"))
     {
      $this->e->add($this->data->e);
      $_session->backend();
      return false;
     }
    }
    else
    {
     $d->setAction("edit");
     
     if(!$this->data->checkField("rootuser")||($this->data->getValue("rootpass")&&(!$this->data->checkField("rootpass")||!$this->data->checkField("verifyrootpass"))))
     {
      $this->e->add($this->data->e);
      $_session->backend();
      return false;
     }
    }

    $d->clearValues();
    $d->setValue($id, $_config->get("rootnr"));
    $d->setValue($catnr, $this->data->getDefaultValue("usercatnr"));
    $d->setValue($username, $this->data->getValue("rootuser"));

    if($this->data->getValue("rootpass"))
     $d->setValue($password, $this->data->getValue("rootpass"));

    foreach($d->check("use", "sql") as $field) //convert to sql values
     if($d->check("use", "form", $field))
      $d->setValue($field, $d->sqlValue($field));

    $dataformat=$d->dataformat;
    $d->dataformat="sql"; //sql format to ensure id is forced

    $_config->su(true);
    if(!$d->submit())
    {
     $_config->su();
     $this->e->add($d->e);
     $_session->backend();
     return false;
    }
    else
     $_config->su();

    $d->dataformat=$dataformat;

    //anonymous user
    if($this->data->getDefaultValue("anonnr")===false)
     $d->setAction("add");
    else
     $d->setAction("edit");

    if(!$this->data->checkField("anonuser"))
    {
     $this->e->add($this->data->e);
     $_session->backend();
     return false;
    }

    $d->clearValues();
    $d->setValue($id, $_config->get("anonnr"));
    $d->setValue($catnr, $this->data->getDefaultValue("usercatnr"));
    $d->setValue($username, $this->data->getValue("anonuser"));
    unset($d->field[$password]); //don't submit password

    foreach($d->check("use", "sql") as $field) //convert to sql values
     if($d->check("use", "form", $field))
      $d->setValue($field, $d->sqlValue($field));

    $dataformat=$d->dataformat;
    $d->dataformat="sql"; //sql format to ensure id is forced

    $_config->su(true);
    if(!$d->submit())
    {
     $_config->su();
     $this->e->add($d->e);
     $_session->backend();
     return false;
    }
    else
     $_config->su();

    $d->dataformat=$dataformat;


    if($_config->userAnonymous()) //not logged in
     if(!$_config->get("groupnrs")) //user not yet in any groups
      $_config->set("groupnrs", Array($this->data->getDefaultValue("usercatnr"))); //add users group

    $this->e->add("Users for project: \"".$_session->get("project")."\" successfully configured", "note");
    $_session->backend();
    return "next";
   }

   $_session->backend();
   return true;
  }


  /*
   * Output
   */

  function output()
  {
   global $_session;

   if(!$this->jasRootUser)
    return "&nbsp; ";

   $_session->frontend();
   $cms=new CMS();
   $_session->backend();

   $cms->l->read("jas");
   $cms->setDataForm($this->data, $this->form);

   $_session->frontend();

   $form="";
   foreach($this->data->check("use", "form") as $field)
    $form.=$cms->field($field);
   
   $_session->backend();

   $form.=$this->confirm(Array("history", (!$this->jasRootUser?"disabled":false)));

   $r=$this->form($form, $this->url("projects/setup/users/"));

   return $r;
  }

 }
?>
