<?

 /*****************************************************************************
 * Filename: project/jas/include/modules/configSites.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class JAS_Module_configSites extends Module
 {
  function __construct(&$data)
  {
   global $_config;

   parent::__construct($data);

   $this->data->title="Sites configuration";

   $this->data->defaultFields("id;added;updated");

   $this->data->setShowFields(); //clear show fields

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all

   $this->data->addField("domain", "domain", "all", "title", 0, 50, "", "Domain name", "Leave empty for default site");
   $this->data->addField("project", "project", "all", "title", 1, 25, false, "Project", "Which project should this site start");
   $this->data->addField("current", "boolean", "show", "", false, false, false, "Currently activated");

   $this->data->addUnique("domain", "domain");
   $this->data->sortOrder("domain");
  }

  function viewPostGet()
  {
   if(!isset($_SERVER["HTTP_HOST"]))
    return true;

   //detect current domain
   $currentSet=false;
   for($c=0;$c<$this->data->vmax;$c++) 
   {
    if($this->data->getValue("domain", $c)==$_SERVER["HTTP_HOST"])
    {
     $this->data->setValue("current", true, $c);
     $currentSet=true;
     break;
    }
    else
     $this->data->setValue("current", false, $c);
   }

   for($c=0;$c<$this->data->vmax;$c++)
   {
    if(!$this->data->getValue("domain", $c)) //default domain
    {
     $this->data->setValue("domain", "default", $c);

     if(!$currentSet) //set default domain as current if no matches found
      $this->data->setValue("current", true, $c);
    }
   }

   return true;
  }

 }

?>
