<?

 /*************************************************************************************
 * Filename: setup.php
 *
 * This file is part of the skeleton JAS plugin.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The skeleton JAS plugin is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/skeleton/
 *************************************************************************************/


 class Plugin_Setup_skeleton extends Base_Plugin_Setup
 {
  function init()
  {
   $this->modules();
   return true;
  }

  function preSetup()
  {
   global $_path;

   $skeletonConf="\n ".'$db["skeleton"]="skeleton_example://";'."\n";

   $conf=false;
   if(file_exists($_path["project"]["include"]."db.conf.php"))
   {
    if(!($conf=@file_get_contents($_path["project"]["include"]."db.conf.php")))
    {
     $this->e->add("Unable to read db.conf.php, please add \"".$skeletonConf."\" manualy", "warning");
     return true;
    }
   }

   if($conf)
   {
    if(strstr($conf, '$db["skeleton"]="skeleton_example://"'))
    {
     $this->e->add("Skeleton DB already in db.conf.php", "note");
     return true;
    }
    else
     $conf=preg_replace("/\?\>/", $skeletonConf."?>", $conf);
   }
   else
    $conf="<?".$skeletonConf."?>";

   if(!(@file_put_contents($_path["project"]["include"]."db.conf.php", $conf)))
   {
    $this->e->add("Unable to write db.conf.php, please add \"".$skeletonConf."\" manualy", "warning");
    return true;
   }

   return true;
  }

  function postSetup()
  {
   return true;
  }

  function preDeSetup()
  {
   return true;
  }

  function postDeSetup()
  {
   return true;
  }

 }
?>
