

 /*****************************************************************************
 * Filename: project/jas/script/icons.js
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


if(typeof(onload)!='function')
 alert("Script not loaded: functions.js");
else if(typeof(setGetElementFunctions)!="function")
 alert("Script not loaded: getelements.js");
else
 onload("initIcons();");

function initIcons()
{
 var icons=document.getElementsByClassName("icon");

 for(var c=0;c<icons.length;c++)
 {
  if(icons[c].tagName.toLowerCase()!="img"||icons[c].parentNode.tagName.toLowerCase()!="a") //not a linked icon image
   continue;

  var m;
  if(!(m=icons[c].src.match(/(.+icons\/[0-9a-z\-]+)(_([a-z]+))?\.png$/i)))
   continue;

  icons[c].parentNode.suffix=(m[3]!=undefined?m[3]:"");
  icons[c].parentNode.onmouseout=iconNormal;
  icons[c].parentNode.onmouseover=iconLink;
  icons[c].parentNode.onmousedown=iconDim;
  icons[c].parentNode.onmouseup=iconLink;
 }
}

function iconNormal(){return switchIcon(this, this.suffix);}
function iconLink(){return switchIcon(this, "link");}
function iconDim(){return switchIcon(this, "dim");}
function iconDisable(){return switchIcon(this, "disabled");}

function switchIcon(link, suffix)
{
 var icon=link.getElementsByTagName("img")[0];

 if(suffix)
  suffix="_"+suffix;

 var m;
 if(m=icon.src.match(/(.+icons\/[0-9a-z\-]+)(\w+)?\.png$/i))
  icon.src=m[1]+suffix+".png";

 return true;
}

